<?php
/*
 Plugin Name: Change WooCommerce Duplicate Behaviour
 Plugin URI: https://techsarathy.com/woocommerce-product-duplicator
 Description: The plugin will ask for user's input to enter a number to duplicate the product that number of times
 Author: Rahul Kumar
 Author URI: https://techsarathy.com
 Version: 1.0.1
 License: GPLv2 or later
 */
function ts_dupe_link( $actions, $post ) {
    if ( ! current_user_can( apply_filters( 'woocommerce_duplicate_product_capability', 'manage_woocommerce' ) ) ) {
        return $actions;
    }

    if ( $post->post_type != 'product' ) {
        return $actions;
    }

    $actions['duplicate'] = '<a href="' . wp_nonce_url( admin_url( 'edit.php?post_type=product&action=duplicate_product&amp;repeat=tsrepeat&amp;post=' . $post->ID ), 'woocommerce-duplicate-product_' . $post->ID ) . '" title="' . esc_attr__( 'Make a duplicate from this product', 'woocommerce' )
        . '" rel="permalink" onclick="function ts(that){var repeat = prompt(\'Please enter Number of copies you want\', \'1\');console.log(repeat==\'\');if(repeat==\'\'){window.event.preventDefault();console.log(repeat);}if (repeat != null) {that.href=that.href.replace(\'tsrepeat\',repeat);}};ts(this);">' .  __( 'Duplicate', 'woocommerce' ) . '</a>';

    return $actions;
}
function ts_duplicate_product_action() {

    if ( empty( $_REQUEST['post'] ) ) {
        wp_die( __( 'No product to duplicate has been supplied!', 'woocommerce' ) );
    }

    // Get the original page
    $id = isset( $_REQUEST['post'] ) ? absint( $_REQUEST['post'] ) : '';

    check_admin_referer( 'woocommerce-duplicate-product_' . $id );
    $dupli=new WC_Admin_Duplicate_Product();
    $post = ts_get_product_to_duplicate( $id );
    $count=isset( $_REQUEST['repeat'] ) ? absint( $_REQUEST['repeat'] ) : 1;
    if($count=='tsrepeat') $count=1;
    // Copy the page and insert it
    if ( ! empty( $post ) ) {
        for($i=0;$i<$count;$i++){
            $new_id = $dupli->duplicate_product( $post );
        }
        // If you have written a plugin which uses non-WP database tables to save
        // information about a page you can hook this action to dupe that data.
        //do_action( 'woocommerce_duplicate_product', $new_id, $post );

        // Redirect to the edit screen for the new draft page
        wp_redirect( admin_url( 'edit.php?post_type=product') );
        exit;
    } else {
        wp_die( __( 'Product creation failed, could not find original product:', 'woocommerce' ) . ' ' . $id );
    }
}
function ts_get_product_to_duplicate( $id ) {
    global $wpdb;

    $id = absint( $id );

    if ( ! $id ) {
        return false;
    }

    $post = $wpdb->get_results( "SELECT * FROM $wpdb->posts WHERE ID=$id" );

    if ( isset( $post->post_type ) && $post->post_type == "revision" ) {
        $id   = $post->post_parent;
        $post = $wpdb->get_results( "SELECT * FROM $wpdb->posts WHERE ID=$id" );
    }

    return $post[0];
}
add_action('plugins_loaded', 'ts_hook_woocommerce');
function ts_hook_woocommerce(){
remove_action( 'admin_action_duplicate_product', array( 'WC_Admin_Duplicate_Product', 'duplicate_product_action' ) );
add_action( 'admin_action_duplicate_product',  'ts_duplicate_product_action'  );
add_filter( 'post_row_actions',  'ts_dupe_link' , 20, 2 );
add_filter( 'page_row_actions',  'ts_dupe_link' , 20, 2 );
}